# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define section free
%define bname   spring-ldap

%define upstream_tag .RELEASE
%define upstream_version %{version}%{?upstream_tag}

Name:           spring-ldap
Summary:        Spring LDAP
Version:        1.3.0
Release:        1%{?dist}
Epoch:          0
License:        ASL 2.0
Group:          Development/Libraries/Application Frameworks
URL:            http://www.springframework.org/
# svn export https://src.springframework.org/svn/spring-ldap/tags/spring-ldap-1.3.0.RELEASE/
# tar czf ../SOURCES/spring-ldap-1.3.0.RELEASE.tgz spring-ldap-1.3.0.RELEASE/

Source0:        %{name}-%{upstream_version}.tgz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Source3:        http://download.java.net/maven/2/com/sun/ldapbp/1.0/ldapbp-1.0.jar
#Source4:        http://repo1.maven.org/maven2/org/springframework/aws/spring-aws-maven/1.2.2/spring-aws-maven-1.2.2.jar
#Source5:        http://repo1.maven.org/maven2/org/springframework/aws/spring-aws-maven/1.2.2/spring-aws-maven-1.2.2.pom
#Source6:        jets3t.jar
Source7:        http://repo1.maven.org/maven2/com/google/code/typica/typica/1.3/typica-1.3.jar
Source8:        http://repo1.maven.org/maven2/com/google/code/typica/typica/1.3/typica-1.3.pom

Patch0:         spring-ldap-core-pom.patch

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-jxr
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  mojo-maven2-plugin-findbugs
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  docbkx
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  spring-build-aws-maven
BuildRequires:  spring2-test

BuildRequires:  aspectj >= 0:1.5.3
BuildRequires:  easymock
BuildRequires:  gsbase
BuildRequires:  hibernate3
BuildRequires:  hsqldb
BuildRequires:  junit4

BuildRequires:  jaf_1_1_api
BuildRequires:  jaxb_2_1_api
BuildRequires:  stax_1_0_api

BuildRequires:  acegi-security
BuildRequires:  annotation_1_0_api
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-pool
BuildRequires:  apacheds10-server-main
BuildRequires:  glassfish-jstl
BuildRequires:  log4j
BuildRequires:  mina10-filter-ssl
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  spring2-aop
BuildRequires:  spring2-beans
BuildRequires:  spring2-core
BuildRequires:  spring2-context
BuildRequires:  spring2-context-support
BuildRequires:  spring2-jdbc
BuildRequires:  spring2-orm
BuildRequires:  spring2-tx
BuildRequires:  spring2-web
BuildRequires:  spring2-webmvc
BuildRequires:  sun-jaxb-2.1-impl

Requires:       java >= 0:1.6.0

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Spring is a layered Java/J2EE application framework, 
based on code published in Expert One-on-One J2EE 
Design and Development by Rod Johnson (Wrox, 2002). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
Requires:       %{name}-javadoc = %{epoch}:%{version}-%{release}

%description manual
%{summary}.

%package devel
Summary:        Source jars for %{name}
Group:          Development/Java

%description devel
%{summary}.

%prep
%setup -q -n %{name}-%{upstream_version}
chmod -R go=u-w *

%patch0 -b .sav0
#%patch1 -b .sav1
#%patch2 -b .sav2

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}

mkdir -p ${MAVEN_REPO_LOCAL}/com/sun/ldapbp/1.0/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/com/sun/ldapbp/1.0/ldapbp-1.0.jar

#mkdir -p ${MAVEN_REPO_LOCAL}/org/springframework/aws/spring-aws-maven/1.2.2/
#cp %{SOURCE4} ${MAVEN_REPO_LOCAL}/org/springframework/aws/spring-aws-maven/1.2.2/spring-aws-maven-1.2.2.jar
#cp %{SOURCE5} ${MAVEN_REPO_LOCAL}/org/springframework/aws/spring-aws-maven/1.2.2/spring-aws-maven-1.2.2.pom

#mkdir -p ${MAVEN_REPO_LOCAL}/net/java/dev/jets3t/jets3t/0.5.1-20080115/
#cp %{SOURCE6} ${MAVEN_REPO_LOCAL}/net/java/dev/jets3t/jets3t/0.5.1-20080115/jets3t-0.5.1-20080115.jar

mkdir -p ${MAVEN_REPO_LOCAL}/com/google/code/typica/typica/1.3/
cp %{SOURCE7} ${MAVEN_REPO_LOCAL}/com/google/code/typica/typica/1.3/typica-1.3.jar
cp %{SOURCE8} ${MAVEN_REPO_LOCAL}/com/google/code/typica/typica/1.3/typica-1.3.pom

export MAVEN_SETTINGS=$(pwd)/settings.xml
#export MAVEN_OPTS="-Xmx256m -XX:MaxPermSize=128m"

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        install
#       -Dmaven.test.skip=true \

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Daggregate=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-sources

install -m 644 target/spring-ldap-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/spring-ldap-sources-%{version}.jar
install -m 644 target/spring-ldap-%{upstream_version}-all.jar \
               $RPM_BUILD_ROOT%{_javadir}/spring-ldap-all-%{version}.jar
install -m 644 core/target/spring-ldap-core-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core-tiger/target/spring-ldap-core-tiger-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tiger-%{version}.jar
install -m 644 test-support/target/spring-ldap-test-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/test-%{version}.jar
install -m 644 test/integration-tests/target/spring-ldap-integration-tests-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-tests-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-sources && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%add_to_maven_depmap org.springframework.ldap %{name} %{version} JPP spring-ldap-all
%add_to_maven_depmap org.springframework.ldap %{name}-core %{version} JPP/%{name} core
%add_to_maven_depmap org.springframework.ldap %{name}-core-tiger %{version} JPP/%{name} core-tiger
%add_to_maven_depmap org.springframework.ldap %{name}-parent %{version} JPP/%{name} parent
%add_to_maven_depmap org.springframework.ldap %{name}-test %{version} JPP/%{name} test
%add_to_maven_depmap org.springframework.ldap %{name}-integration-tests-parent %{version} JPP/%{name} itest-parent
%add_to_maven_depmap org.springframework.ldap %{name}-integration-tests %{version} JPP/%{name} integration-tests

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-all.pom
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
install -m 644 core-tiger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core-tiger.pom
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
install -m 644 test-support/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-test.pom
install -m 644 test/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-itest-parent.pom
install -m 644 test/integration-tests/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-tests.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/*.jar
%{_javadir}/%{name}/*.jar
%{_javadir}/%{name}-sources
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sun Jun 26 2011 Ralph Apel <r.apel@r-apel.de> 0:1.3.0-1
- 1.3.0

* Tue May 10 2011 Ralph Apel <r.apel@r-apel.de> 0:1.2.1-1
- First release

